Package com.complexible.stardog.reasoning

# Class ReasoningOptions

java.lang.Object
com.complexible.stardog.reasoning.ReasoningOptions

All Implemented Interfaces:
  `MetaPropertyProvider`

public final class ReasoningOptions extends Object implements MetaPropertyProvider
Options for controlling reasoning behavior.

Since:
  3.0
Version:
  7.2.1
Author:
  Evren Sirin

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ConfigProperty<Boolean>`
  `APPROXIMATE`
  Flag to enable approximate reasoning.
  `static final ConfigProperty<Boolean>`
  `CONSISTENCY_AUTOMATIC`
  Option to specify if consistency checking should be performed automatically during reasoning.
  `static final IRI`
  `DEFAULT_SCHEMA_GRAPH_IRI`
  `static final ConfigProperty<Boolean>`
  `DOMAIN_RANGE_OPTIMIZATION`
  `static final ConfigProperty<Boolean>`
  `EAGER_CLASSIFY`
  Flag to perform schema classification eagerly when the schema is loaded.
  `static final ConfigProperty<Boolean>`
  `ENABLE_SCHEMA_VERSIONING`
  `static final ConfigProperty<com.complexible.stardog.index.EqualityReasoningLevel>`
  `EQUALITY_REASONING`
  Database option to specify the expressivity level to be used when performing equality reasoning.
  `static final ConfigProperty<Boolean>`
  `OPTIMIZE`
  `static final ConfigProperty<Boolean>`
  `PRECOMPUTE_NON_EMPTY_TERMS`
  `static final ConfigProperty<Boolean>`
  `PUNNING_ENABLED`
  Enables punning; the ability for an IRI to represent both a class and an individual.
  `static final ConfigProperty<ReasoningType>`
  `REASONING_TYPE`
  Database option to specify the expressivity level to be used when performing reasoning.
  `static final ConfigProperty<Integer>`
  `REWRITE_LIMIT`
  `static final ConfigProperty<com.complexible.stardog.reasoning.RewritingStrategy>`
  `REWRITING_STRATEGY`
  `static final ConfigProperty<Collection<IRI>>`
  `SCHEMA_GRAPHS`
  Option to specify the named graphs from where the default schema (ontology, "TBox") should be extracted.
  `static final ConfigProperty<Duration>`
  `SCHEMA_REASONING_TIMEOUT`
  Timeout for schema reasoning.
  `static final ConfigProperty<Collection<com.complexible.stardog.reasoning.SchemaGraph>>`
  `SCHEMAS`
  Option to specify the named schemas and the named graphs that constitute each schema.
  `static final ConfigProperty<Integer>`
  `SCHEMAS_MEMORY_COUNT`
  Option to specify the number of `schemas` to keep in memory.
  `static final ConfigProperty<Boolean>`
  `STRIDE`
  `static final ConfigProperty<Boolean>`
  `VIRTUAL_GRAPH`
  Flag to enable reasoning over virtual graphs and SERVICE clauses.

- ## Method Summary

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_SCHEMA_GRAPH_IRI

    public static final IRI DEFAULT_SCHEMA_GRAPH_IRI

  - ### EQUALITY_REASONING

    public static final ConfigProperty<com.complexible.stardog.index.EqualityReasoningLevel> EQUALITY_REASONING
    Database option to specify the expressivity level to be used when performing equality reasoning. When this option is set to ON reflexive, symmetric, and transitive closure of the `owl:sameAs` triples in the database is computed. When it is set to FULL, all inferences from On are kept but additional `owl:sameAs` inferences are computed based on the schema axioms such as functional properties. Only the default schema is used in the FULL mode.

  - ### SCHEMA_GRAPHS

    public static final ConfigProperty<Collection<IRI>> SCHEMA_GRAPHS
    Option to specify the named graphs from where the default schema (ontology, "TBox") should be extracted. The value is a collection of named graph IRIs. The default value is `tag:stardog:api:context:schema`.

  - ### SCHEMAS

    public static final ConfigProperty<Collection<com.complexible.stardog.reasoning.SchemaGraph>> SCHEMAS
    Option to specify the named schemas and the named graphs that constitute each schema. There should be one `SchemaGraph` instance for each named graph in a schema. The graphs for the default schema are set via the `SCHEMA_GRAPHS` option and only the graphs for named schemas are set via this option. The default value is an empty collection indicating there are no named schemas in the database.

  - ### ENABLE_SCHEMA_VERSIONING

    public static final ConfigProperty<Boolean> ENABLE_SCHEMA_VERSIONING

  - ### SCHEMAS_MEMORY_COUNT

    public static final ConfigProperty<Integer> SCHEMAS_MEMORY_COUNT
    Option to specify the number of `schemas` to keep in memory. There can be more schemas defined in the database but only this many schemas will be kept in memory and other schemas will be pulled into memory as queries are getting answered. If this limit is too high amount of memory used for schemas will increase and might cause memory problems. If it is too low then answering reasoning queries might slow down.

  - ### PUNNING_ENABLED

    public static final ConfigProperty<Boolean> PUNNING_ENABLED
    Enables punning; the ability for an IRI to represent both a class and an individual.

  - ### CONSISTENCY_AUTOMATIC

    public static final ConfigProperty<Boolean> CONSISTENCY_AUTOMATIC
    Option to specify if consistency checking should be performed automatically during reasoning. If this option is turned on, Stardog will perform consistency checking any time a query through a reasoner connection (see its isConsistent() method). If the underlying database did not change since the last consistency check, the consistency check will not be performed. By default, this option is turned off meaning consistency check will only be performed when the isConsistent() function is explicitly called.

  - ### SCHEMA_REASONING_TIMEOUT

    public static final ConfigProperty<Duration> SCHEMA_REASONING_TIMEOUT
    Timeout for schema reasoning. If schema reasoning cannot be completed in the specified time then only RDFS reasoning will be performed for the schema which might yield incomplete answers for the schema queries. The timeout values specified as test be a positive integer followed by either letter 'h' (for hours), letter 'm' (for minutes), letter 's' (for seconds), or letters 'ms' (for milliseconds). Examples: '1h' for 1 hour, '5m' for 5 minutes, '90s' for 90 seconds, '500ms' for 500 milliseconds.

  - ### REASONING_TYPE

    public static final ConfigProperty<ReasoningType> REASONING_TYPE
    Database option to specify the expressivity level to be used when performing reasoning.

  - ### APPROXIMATE

    public static final ConfigProperty<Boolean> APPROXIMATE
    Flag to enable approximate reasoning. With this flag enabled Stardog will approximate an axiom that is outside the profile Stardog supports and normally ignored. For example, an equivalent class axiom might be split into two subclass axioms and only one subclass axiom is used.

  - ### VIRTUAL_GRAPH

    public static final ConfigProperty<Boolean> VIRTUAL_GRAPH
    Flag to enable reasoning over virtual graphs and SERVICE clauses. If this option is enabled then the virtual graph and SERVICE clauses will be rewritten with respect to the scheme of the database and the rewritten query will be sent for evaluation. If this option is disabled virtual graph queries will be evaluated as is.

  - ### EAGER_CLASSIFY

    public static final ConfigProperty<Boolean> EAGER_CLASSIFY
    Flag to perform schema classification eagerly when the schema is loaded. Classifying eagerly ensures subclass and equivalence queries between named classes can be answered with a simple lookup. However, if the schema is changing frequently then this option can be turned off so classification is performed only if necessary.

  - ### PRECOMPUTE_NON_EMPTY_TERMS

    public static final ConfigProperty<Boolean> PRECOMPUTE_NON_EMPTY_TERMS

  - ### DOMAIN_RANGE_OPTIMIZATION

    public static final ConfigProperty<Boolean> DOMAIN_RANGE_OPTIMIZATION

  - ### REWRITING_STRATEGY

    public static final ConfigProperty<com.complexible.stardog.reasoning.RewritingStrategy> REWRITING_STRATEGY

  - ### OPTIMIZE

    public static final ConfigProperty<Boolean> OPTIMIZE

  - ### STRIDE

    public static final ConfigProperty<Boolean> STRIDE

  - ### REWRITE_LIMIT

    public static final ConfigProperty<Integer> REWRITE_LIMIT